FilterIndexReader (Lucene 3.6.2 API)
Keywords: org.apache.lucene.index.FilterIndexReader class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.index
Class FilterIndexReader

    java.lang.Object
      org.apache.lucene.index.IndexReader
          org.apache.lucene.index.FilterIndexReader

All Implemented Interfaces:
  Closeable, Cloneable

Direct Known Subclasses:
  PruningReader

    public class FilterIndexReader

extends IndexReader

A `FilterIndexReader` contains another IndexReader, which it uses as its basic source of data, possibly transforming the data along the way or providing additional functionality. The class `FilterIndexReader` itself simply implements all abstract methods of `IndexReader` with versions that pass all requests to the contained index reader. Subclasses of `FilterIndexReader` may further override some of these methods and may also provide additional methods and fields.

Note: The default implementation of `IndexReader.doOpenIfChanged()` throws `UnsupportedOperationException` (like the base class), so it's not possible to reopen a `FilterIndexReader`. To reopen, you have to first reopen the underlying reader and wrap it again with the custom filter.

Nested Class Summary
`static class` | `FilterIndexReader.FilterTermDocs` Base class for filtering `TermDocs` implementations.
`static class` | `FilterIndexReader.FilterTermEnum` Base class for filtering `TermEnum` implementations.
`static class` | `FilterIndexReader.FilterTermPositions` Base class for filtering `TermPositions` implementations.

Nested classes/interfaces inherited from class org.apache.lucene.index.IndexReader
`IndexReader.ReaderClosedListener`

Field Summary
`protected IndexReader` | `in`

Fields inherited from class org.apache.lucene.index.IndexReader
`hasChanges`

Constructor Summary
`FilterIndexReader(IndexReader in)` Construct a FilterIndexReader based on the specified base reader.

Method Summary
`Directory` | `directory()` Returns the directory associated with this index.
`int` | `docFreq(Term t)` Returns the number of documents containing the term `t`.
`protected void` | `doClose()` Implements close.
`protected void` | `doCommit(Map<String,String> commitUserData)` Deprecated.
`Document` | `document(int n, FieldSelector fieldSelector)` Get the `Document` at the `n` th position.
`protected void` | `doDelete(int n)` Deprecated.
`protected void` | `doSetNorm(int d, String f, byte b)` Deprecated.
`protected void` | `doUndeleteAll()` Deprecated.
`Map<String,String>` | `getCommitUserData()` Retrieve the String userData optionally passed to IndexWriter#commit.
`Object` | `getCoreCacheKey()` If the subclass of FilteredIndexReader modifies the contents of the FieldCache, you must override this method to provide a different key
`Object` | `getDeletesCacheKey()` If the subclass of FilteredIndexReader modifies the deleted docs, you must override this method to provide a different key
`FieldInfos` | `getFieldInfos()` Get the `FieldInfos` describing all fields in this reader.
`IndexCommit` | `getIndexCommit()` Expert: return the IndexCommit that this reader has opened.
`IndexReader[]` | `getSequentialSubReaders()` Expert: returns the sequential sub readers that this reader is logically composed of.
`TermFreqVector` | `getTermFreqVector(int docNumber, String field)` Return a term frequency vector for the specified document and field.
`void` | `getTermFreqVector(int docNumber, String field, TermVectorMapper mapper)` Load the Term Vector into a user-defined data structure instead of relying on the parallel arrays of the `TermFreqVector`.
`void` | `getTermFreqVector(int docNumber, TermVectorMapper mapper)` Map all the term vectors for all fields in a Document
`TermFreqVector[]` | `getTermFreqVectors(int docNumber)` Return an array of term frequency vectors for the specified document.
`int` | `getTermInfosIndexDivisor()` For IndexReader implementations that use TermInfosReader to read terms, this returns the current indexDivisor as specified when the reader was opened.
`long` | `getUniqueTermCount()` Returns the number of unique terms (across all fields) in this reader.
`long` | `getVersion()` Version number when this IndexReader was opened.
`boolean` | `hasDeletions()` Returns true if any documents have been deleted
`boolean` | `hasNorms(String field)` Returns true if there are norms stored for this field.
`boolean` | `isCurrent()` Check whether any new changes have occurred to the index since this reader was opened.
`boolean` | `isDeleted(int n)` Returns true if document n has been deleted
`boolean` | `isOptimized()` Deprecated.
`int` | `maxDoc()` Returns one greater than the largest possible document number.
`byte[]` | `norms(String f)` Returns the byte-encoded normalization factor for the named field of every document.
`void` | `norms(String f, byte[] bytes, int offset)` Reads the byte-encoded normalization factor for the named field of every document.
`int` | `numDocs()` Returns the number of documents in this index.
`TermDocs` | `termDocs()` Returns an unpositioned `TermDocs` enumerator.
`TermDocs` | `termDocs(Term term)` Returns an enumeration of all the documents which contain `term`.
`TermPositions` | `termPositions()` Returns an unpositioned `TermPositions` enumerator.
`TermEnum` | `terms()` Returns an enumeration of all the terms in the index.
`TermEnum` | `terms(Term t)` Returns an enumeration of all terms starting at a given term.
`String` | `toString()`

Methods inherited from class org.apache.lucene.index.IndexReader
`acquireWriteLock, addReaderClosedListener, clone, clone, close, commit, commit, decRef, deleteDocument, deleteDocuments, document, doOpenIfChanged, doOpenIfChanged, doOpenIfChanged, doOpenIfChanged, ensureOpen, flush, flush, getCommitUserData, getCurrentVersion, getRefCount, incRef, indexExists, lastModified, listCommits, numDeletedDocs, open, open, open, open, open, open, open, open, open, open, open, openIfChanged, openIfChanged, openIfChanged, openIfChanged, removeReaderClosedListener, reopen, reopen, reopen, reopen, setNorm, setNorm, termPositions, tryIncRef, undeleteAll`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### in

    protected IndexReader in

Constructor Detail

### FilterIndexReader

    public FilterIndexReader(IndexReader in)

  Construct a FilterIndexReader based on the specified base reader. Directory locking for delete, undeleteAll, and setNorm operations is left to the base reader.

  Note that base reader is closed if this FilterIndexReader is closed.

  Parameters:
    `in` - specified base reader.

Method Detail

### directory

    public Directory directory()

  Description copied from class: `IndexReader`
  Returns the directory associated with this index. The Default implementation returns the directory specified by subclasses when delegating to the IndexReader(Directory) constructor, or throws an UnsupportedOperationException if one was not specified.

  Overrides:
    `directory` in class `IndexReader`

### getIndexCommit

    public IndexCommit getIndexCommit()
                               throws IOException

  Description copied from class: `IndexReader`
  Expert: return the IndexCommit that this reader has opened. This method is only implemented by those readers that correspond to a Directory with its own segments_N file.

  Overrides:
    `getIndexCommit` in class `IndexReader`
  Throws:
    `IOException`

### getFieldInfos

    public FieldInfos getFieldInfos()

  Description copied from class: `IndexReader`
  Get the `FieldInfos` describing all fields in this reader. NOTE: do not make any changes to the returned FieldInfos!

  Specified by:
    `getFieldInfos` in class `IndexReader`

### getTermInfosIndexDivisor

    public int getTermInfosIndexDivisor()

  Description copied from class: `IndexReader`
  For IndexReader implementations that use TermInfosReader to read terms, this returns the current indexDivisor as specified when the reader was opened.

  Overrides:
    `getTermInfosIndexDivisor` in class `IndexReader`

### getTermFreqVectors

    public TermFreqVector[] getTermFreqVectors(int docNumber)
                                        throws IOException

  Description copied from class: `IndexReader`
  Return an array of term frequency vectors for the specified document. The array contains a vector for each vectorized field in the document. Each vector contains terms and frequencies for all terms in a given vectorized field. If no such fields existed, the method returns null. The term vectors that are returned may either be of type `TermFreqVector` or of type `TermPositionVector` if positions or offsets have been stored.

  Specified by:
    `getTermFreqVectors` in class `IndexReader`
  Parameters:
    `docNumber` - document for which term frequency vectors are returned
  Returns:
    array of term frequency vectors. May be null if no term vectors have been stored for the specified document.
  Throws:
    `IOException` - if index cannot be accessed
  See Also:
    `Field.TermVector`

### getTermFreqVector

    public TermFreqVector getTermFreqVector(int docNumber,
                                            String field)
                                     throws IOException

  Description copied from class: `IndexReader`
  Return a term frequency vector for the specified document and field. The returned vector contains terms and frequencies for the terms in the specified field of this document, if the field had the storeTermVector flag set. If termvectors had been stored with positions or offsets, a `TermPositionVector` is returned.

  Specified by:
    `getTermFreqVector` in class `IndexReader`
  Parameters:
    `docNumber` - document for which the term frequency vector is returned
    `field` - field for which the term frequency vector is returned.
  Returns:
    term frequency vector May be null if field does not exist in the specified document or term vector was not stored.
  Throws:
    `IOException` - if index cannot be accessed
  See Also:
    `Field.TermVector`

### getTermFreqVector

    public void getTermFreqVector(int docNumber,
                                  String field,
                                  TermVectorMapper mapper)
                           throws IOException

  Description copied from class: `IndexReader`
  Load the Term Vector into a user-defined data structure instead of relying on the parallel arrays of the `TermFreqVector`.

  Specified by:
    `getTermFreqVector` in class `IndexReader`
  Parameters:
    `docNumber` - The number of the document to load the vector for
    `field` - The name of the field to load
    `mapper` - The `TermVectorMapper` to process the vector. Must not be null
  Throws:
    `IOException` - if term vectors cannot be accessed or if they do not exist on the field and doc. specified.

### getTermFreqVector

    public void getTermFreqVector(int docNumber,
                                  TermVectorMapper mapper)
                           throws IOException

  Description copied from class: `IndexReader`
  Map all the term vectors for all fields in a Document

  Specified by:
    `getTermFreqVector` in class `IndexReader`
  Parameters:
    `docNumber` - The number of the document to load the vector for
    `mapper` - The `TermVectorMapper` to process the vector. Must not be null
  Throws:
    `IOException` - if term vectors cannot be accessed or if they do not exist on the field and doc. specified.

### getUniqueTermCount

    public long getUniqueTermCount()
                            throws IOException

  Description copied from class: `IndexReader`
  Returns the number of unique terms (across all fields) in this reader. This method returns long, even though internally Lucene cannot handle more than 2^31 unique terms, for a possible future when this limitation is removed.

  Overrides:
    `getUniqueTermCount` in class `IndexReader`
  Throws:
    `IOException`

### numDocs

    public int numDocs()

  Description copied from class: `IndexReader`
  Returns the number of documents in this index.

  Specified by:
    `numDocs` in class `IndexReader`

### maxDoc

    public int maxDoc()

  Description copied from class: `IndexReader`
  Returns one greater than the largest possible document number. This may be used to, e.g., determine how big to allocate an array which will have an element for every document number in an index.

  Specified by:
    `maxDoc` in class `IndexReader`

### document

    public Document document(int n,
                             FieldSelector fieldSelector)
                      throws CorruptIndexException,
                             IOException

  Description copied from class: `IndexReader`
  Get the `Document` at the `n` th position. The `FieldSelector` may be used to determine what `Field`s to load and how they should be loaded. NOTE: If this Reader (more specifically, the underlying `FieldsReader`) is closed before the lazy `Field` is loaded an exception may be thrown. If you want the value of a lazy `Field` to be available after closing you must explicitly load it or fetch the Document again with a new loader.

  NOTE: for performance reasons, this method does not check if the requested document is deleted, and therefore asking for a deleted document may yield unspecified results. Usually this is not required, however you can call `IndexReader.isDeleted(int)` with the requested document ID to verify the document is not deleted.

  Specified by:
    `document` in class `IndexReader`
  Parameters:
    `n` - Get the document at the `n`th position
    `fieldSelector` - The `FieldSelector` to use to determine what Fields should be loaded on the Document. May be null, in which case all Fields will be loaded.
  Returns:
    The stored fields of the `Document` at the nth position
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error
  See Also:
    `Fieldable`, `FieldSelector`, `SetBasedFieldSelector`, `LoadFirstFieldSelector`

### isDeleted

    public boolean isDeleted(int n)

  Description copied from class: `IndexReader`
  Returns true if document n has been deleted

  Specified by:
    `isDeleted` in class `IndexReader`

### hasDeletions

    public boolean hasDeletions()

  Description copied from class: `IndexReader`
  Returns true if any documents have been deleted

  Specified by:
    `hasDeletions` in class `IndexReader`

### doUndeleteAll

    @Deprecated
    protected void doUndeleteAll()
                          throws CorruptIndexException,
                                 IOException

  Deprecated.

  Implements actual undeleteAll() in subclass.

  Specified by:
    `doUndeleteAll` in class `IndexReader`
  Throws:
    `CorruptIndexException`
    `IOException`

### hasNorms

    public boolean hasNorms(String field)
                     throws IOException

  Description copied from class: `IndexReader`
  Returns true if there are norms stored for this field.

  Overrides:
    `hasNorms` in class `IndexReader`
  Throws:
    `IOException`

### norms

    public byte[] norms(String f)
                 throws IOException

  Description copied from class: `IndexReader`
  Returns the byte-encoded normalization factor for the named field of every document. This is used by the search code to score documents. Returns null if norms were not indexed for this field.

  Specified by:
    `norms` in class `IndexReader`
  Throws:
    `IOException`
  See Also:
    `AbstractField.setBoost(float)`

### norms

    public void norms(String f,
                      byte[] bytes,
                      int offset)
               throws IOException

  Description copied from class: `IndexReader`
  Reads the byte-encoded normalization factor for the named field of every document. This is used by the search code to score documents.

  Specified by:
    `norms` in class `IndexReader`
  Throws:
    `IOException`
  See Also:
    `AbstractField.setBoost(float)`

### doSetNorm

    @Deprecated
    protected void doSetNorm(int d,
                                        String f,
                                        byte b)
                      throws CorruptIndexException,
                             IOException

  Deprecated.

  Implements setNorm in subclass.

  Specified by:
    `doSetNorm` in class `IndexReader`
  Throws:
    `CorruptIndexException`
    `IOException`

### terms

    public TermEnum terms()
                   throws IOException

  Description copied from class: `IndexReader`
  Returns an enumeration of all the terms in the index. The enumeration is ordered by Term.compareTo(). Each term is greater than all that precede it in the enumeration. Note that after calling terms(), `TermEnum.next()` must be called on the resulting enumeration before calling other methods such as `TermEnum.term()`.

  Specified by:
    `terms` in class `IndexReader`
  Throws:
    `IOException` - if there is a low-level IO error

### terms

    public TermEnum terms(Term t)
                   throws IOException

  Description copied from class: `IndexReader`
  Returns an enumeration of all terms starting at a given term. If the given term does not exist, the enumeration is positioned at the first term greater than the supplied term. The enumeration is ordered by Term.compareTo(). Each term is greater than all that precede it in the enumeration.

  Specified by:
    `terms` in class `IndexReader`
  Throws:
    `IOException` - if there is a low-level IO error

### docFreq

    public int docFreq(Term t)
                throws IOException

  Description copied from class: `IndexReader`
  Returns the number of documents containing the term `t`.

  Specified by:
    `docFreq` in class `IndexReader`
  Throws:
    `IOException` - if there is a low-level IO error

### termDocs

    public TermDocs termDocs()
                      throws IOException

  Description copied from class: `IndexReader`
  Returns an unpositioned `TermDocs` enumerator.

  Note: the TermDocs returned is unpositioned. Before using it, ensure that you first position it with `TermDocs.seek(Term)` or `TermDocs.seek(TermEnum)`.

  Specified by:
    `termDocs` in class `IndexReader`
  Throws:
    `IOException` - if there is a low-level IO error

### termDocs

    public TermDocs termDocs(Term term)
                      throws IOException

  Description copied from class: `IndexReader`
  Returns an enumeration of all the documents which contain `term`. For each document, the document number, the frequency of the term in that document is also provided, for use in search scoring. If term is null, then all non-deleted docs are returned with freq=1. Thus, this method implements the mapping:

  Term => <docNum, freq>*

  The enumeration is ordered by document number. Each document number is greater than all that precede it in the enumeration.

  Overrides:
    `termDocs` in class `IndexReader`
  Throws:
    `IOException` - if there is a low-level IO error

### termPositions

    public TermPositions termPositions()
                                throws IOException

  Description copied from class: `IndexReader`
  Returns an unpositioned `TermPositions` enumerator.

  Specified by:
    `termPositions` in class `IndexReader`
  Throws:
    `IOException` - if there is a low-level IO error

### doDelete

    @Deprecated
    protected void doDelete(int n)
                     throws CorruptIndexException,
                            IOException

  Deprecated.

  Implements deletion of the document numbered `docNum`. Applications should call `IndexReader.deleteDocument(int)` or `IndexReader.deleteDocuments(Term)`.

  Specified by:
    `doDelete` in class `IndexReader`
  Throws:
    `CorruptIndexException`
    `IOException`

### doCommit

    @Deprecated
    protected void doCommit(Map<String,String> commitUserData)
                     throws IOException

  Deprecated.

  Implements commit.

  Specified by:
    `doCommit` in class `IndexReader`
  Throws:
    `IOException`

### doClose

    protected void doClose()
                    throws IOException

  Description copied from class: `IndexReader`
  Implements close.

  Specified by:
    `doClose` in class `IndexReader`
  Throws:
    `IOException`

### getVersion

    public long getVersion()

  Description copied from class: `IndexReader`
  Version number when this IndexReader was opened. Not implemented in the IndexReader base class.

  If this reader is based on a Directory (ie, was created by calling `IndexReader.open(org.apache.lucene.store.Directory)`, or `IndexReader.openIfChanged(org.apache.lucene.index.IndexReader)` on a reader based on a Directory), then this method returns the version recorded in the commit that the reader opened. This version is advanced every time `IndexWriter.commit()` is called.

  Overrides:
    `getVersion` in class `IndexReader`

### isCurrent

    public boolean isCurrent()
                      throws CorruptIndexException,
                             IOException

  Description copied from class: `IndexReader`
  Check whether any new changes have occurred to the index since this reader was opened.

  If this reader is based on a Directory (ie, was created by calling `IndexReader.open(org.apache.lucene.store.Directory)`, or `IndexReader.openIfChanged(org.apache.lucene.index.IndexReader)` on a reader based on a Directory), then this method checks if any further commits (see `IndexWriter.commit()` have occurred in that directory).

  If instead this reader is a near real-time reader (ie, obtained by a call to `IndexWriter.getReader()`, or by calling `IndexReader.openIfChanged(org.apache.lucene.index.IndexReader)` on a near real-time reader), then this method checks if either a new commmit has occurred, or any new uncommitted changes have taken place via the writer. Note that even if the writer has only performed merging, this method will still return false.

  In any event, if this returns false, you should call `IndexReader.openIfChanged(org.apache.lucene.index.IndexReader)` to get a new reader that sees the changes.

  Overrides:
    `isCurrent` in class `IndexReader`
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### isOptimized

    @Deprecated
    public boolean isOptimized()

  Deprecated.

  Overrides:
    `isOptimized` in class `IndexReader`

### getSequentialSubReaders

    public IndexReader[] getSequentialSubReaders()

  Description copied from class: `IndexReader`
  Expert: returns the sequential sub readers that this reader is logically composed of. For example, IndexSearcher uses this API to drive searching by one sub reader at a time. If this reader is not composed of sequential child readers, it should return null. If this method returns an empty array, that means this reader is a null reader (for example a MultiReader that has no sub readers).

  NOTE: You should not try using sub-readers returned by this method to make any changes (setNorm, deleteDocument, etc.). While this might succeed for one composite reader (like MultiReader), it will most likely lead to index corruption for other readers (like DirectoryReader obtained through `IndexReader.open(org.apache.lucene.store.Directory)`. Use the parent reader directly.

  Overrides:
    `getSequentialSubReaders` in class `IndexReader`

### getCommitUserData

    public Map<String,String> getCommitUserData()

  Description copied from class: `IndexReader`
  Retrieve the String userData optionally passed to IndexWriter#commit. This will return null if `IndexWriter.commit(Map)` has never been called for this index.

  Overrides:
    `getCommitUserData` in class `IndexReader`

### getCoreCacheKey

    public Object getCoreCacheKey()

  If the subclass of FilteredIndexReader modifies the contents of the FieldCache, you must override this method to provide a different key

  Overrides:
    `getCoreCacheKey` in class `IndexReader`

### getDeletesCacheKey

    public Object getDeletesCacheKey()

  If the subclass of FilteredIndexReader modifies the deleted docs, you must override this method to provide a different key

  Overrides:
    `getDeletesCacheKey` in class `IndexReader`

### toString

    public String toString()

  Overrides:
    `toString` in class `IndexReader`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD